#include "effects.h"



void fire(PyObject *screen) {
	int x,y,i;
	Uint8 *pixels;
	SDL_Surface *surf = PySurface_AsSurface(screen);
	int pitch = surf->pitch;
	Uint8 v;
	
	y = surf->h-1;
	pixels = surf->pixels + surf->pitch*y;
		
	for (x = 0; x<surf->w; x++) {
		//v = 192+rand()%64; 
		v = *(pixels) + (rand()%3 - 1)*4;
		//v = (*(pixels-1)+*(pixels)*2+*(pixels+1)/4) + (rand()%3 - 1)*64;
		*(pixels++) = v;
		}
	
	for (y = 0; y<surf->h-1; y++) {
		pixels = surf->pixels + pitch*y;
		for (x=1; x<surf->w-1; x++) {
			v = (*(pixels) + *(pixels-1+pitch) + *(pixels+pitch) + *(pixels+pitch+1)) /4 ;
			*(pixels++) = v;
			}
		}
	}
	
void mandel_lines(PyObject *screen, float a1,float b1, float a2, float b2,int y1, int y2) {
	int x,y;
	float a,b,ac,bc,an,bn;
	Uint8 i;
	Uint8 *pixels;
	SDL_Surface *surf = PySurface_AsSurface(screen);
	
	float ai = (a2-a1)/surf->w;
	float bi = (b2-b1)/surf->h;
	
	for (y=y1,bc=b1+bi*y1; y<y2; y++,bc+=bi) {
		pixels = surf->pixels + surf->pitch*y;
		ac = a1;
		for (x =0 ; x<surf->w; x++,ac+=ai) {
			i=0;
			a = ac; b = bc;
			while (i < 255 && (a*a)+(b*b)<4.0){
				an=(a*a)-(b*b)+ac;
				bn=(2.0*a*b)+bc;
				a=an; b=bn;
				i ++;
				}
			*(pixels++) = i;
			}
		}
	}

void mandel(PyObject *screen, float a1,float b1, float a2, float b2) {
	SDL_Surface *surf = PySurface_AsSurface(screen);
	mandel_lines(screen,a1,b1,a2,b2,0,surf->h);
	}
	
void combo(PyObject *s_, PyObject *s1_, PyObject *s2_) {
	int x,y;
	int v,v1,v2;
	SDL_Surface *s = PySurface_AsSurface(s_);
	SDL_Surface *s1 = PySurface_AsSurface(s1_);
	SDL_Surface *s2 = PySurface_AsSurface(s2_);
	Uint8 *p; 
	Uint8 *p1;
	Uint8 *p2;
	
	int flip1 = rand()%2;
	int flip2 = rand()%2;
	int meth = rand()%5;
	int flipv = rand()%2; //NOTE: probably redundant
		
	for (y=0; y<s->h; y++) {
		p = s->pixels + y*s->pitch;
		p1 = s1->pixels + y*s1->pitch;
		p2 = s2->pixels + y*s2->pitch;
		for (x=0; x<s->w; x++) {
			v1 = *(p1);
			v2 = *(p2);
			if (flip1) v1 = 0xff-v1;
			if (flip2) v2 = 0xff-v2;
			switch (meth) {
				case 0: v = (v1+v2)/2; break;
				case 1: v = v1-v2; break;
				case 2: v = v1-v2; if (v<0) v=-v; break;
				case 3: v = v1; if (v2<v) v = v2; break;
				case 4: v = v1; if (v2>v) v = v2; break;
				}
			if (v < 0) v = 0;
			if (v > 0xff) v = 0xff;
			if (flipv) v = 0xff-v;
			*(p) = (Uint8)v;
			p++;
			p1++;
			p2++;
			}
		}
	}
//
