from random import *

import pygame
from pygame.locals import *

import effects

W,H = 640,480

class fract:
	def __init__(self,s,x1,y1,x2,y2):
		self.s,self.x1,self.y1,self.x2,self.y2 = s,x1,y1,x2,y2
	def lines(self,y1,y2):
		effects.mandel_lines(self.s,self.x1,self.y1,self.x2,self.y2,y1,y2)
		
class gen:
	def __init__(self):
		#mini mandel
		m = pygame.Surface((200,200),0,8)
		effects.mandel(m,-1,-1,1,1)
		self.mini = m
		
		self._start()
		
	def _start(self):
		px,py = self.findspot()
		px,py = px/100.0-1.0,py/100.0-1.0
		s = pygame.Surface((W,H),0,8)
		z = float(randrange(2,8))
		x1,y1,x2,y2 = px-z/H,py-z/W,px+z/H,py+z/W
		self.s1 = fract(s,x1,y1,x2,y2)
		
		px,py = self.findspot()
		px,py = px/100.0-1.0,py/100.0-1.0
		s = pygame.Surface((W,H),0,8)
		z = float(randrange(2,8))
		x1,y1,x2,y2 = px-z/H,py-z/W,px+z/H,py+z/W
		self.s2 = fract(s,x1,y1,x2,y2)
		
		s = pygame.Surface((W,H),0,8)
		s.set_palette(self.newpal())
		self.s = s

		self.y = 0
		
		
	def work(self,n=1):
		yy = min(H,self.y+n)
		if yy == self.y: return
		self.s1.lines(self.y,yy)
		self.s2.lines(self.y,yy)
		self.y = yy
		
	def get(self):
		if self.y < H: self.work(H-self.y)
		effects.combo(self.s,self.s1.s,self.s2.s)
		s = self.s
		self._start()
		return s
				
	
	def newpal(self):
		g = []
		
		v = [0,0,0]
		g.append(v[:])
		
		n = randrange(1,3)
		
		for x in range(0,n):
			v = [0,0,0]
			s = sample([0,1,2],2)
			i = randrange(0,256)
			v[s[0]] = i
			v[s[1]] = 255-i
			g.append(v[:])
			
		
		v = [255,255,255]
		g.append(v[:])
		g.append(v[:]) #HACK: for some overrun 
		#n-=1
		
		#print g
		
		n += 1
		d = 256/n 
		p = []
		for i in range(0,256):
			v = []
			c = i%d
			for j in range(0,3):
				vv = (g[int(i/d)][j]*(d-c) + g[int(i/d+1)][j]*c ) / d
				vv = pow(vv/255.0,1.0/2.2)
				vv = int(vv*255.0)
				v.append(vv)
			p.append(v)
		
		p[255] = [255,255,255]
		
		return p
	
	def findspot(self):
		surf = self.mini
		w,h = surf.get_width(),surf.get_height()
		#s = pygame.surfarray.array2d(surf)
		s = surf
		p = [(n,n,n) for n in range(0,256)]
		s.set_palette(p)
		i = 0
		while i < 128 or i == 255: 
			px,py = randrange(0,w),randrange(0,h)
			#i = s[px][py]
			i = s.get_at((px,py))[0]
		return px,py
	
		
