from distutils.core import setup, Extension
try:
	import py2exe
except:
	pass
	
import sys
import glob
import os
import shutil

cmd = sys.argv[1]

data = [
	'*.wav',
	'*.ttf',
	'*.tga',
	'*.png',
	'*.MOD',
	'*.XM',
	'*.ico',
	'README',
	'COPYING',
	]
src = [
	'*.py',
	'*.c',
	'*.h',
	'*.i',
	]

if cmd in ('sdist'): 
	f = open("MANIFEST.in","w")
	for l in data: f.write("include "+l+"\n")
	for l in src: f.write("include "+l+"\n")
	f.close()
	
		
if cmd in ('sdist','build'):
	setup(
		name='ftetris',
		version='1.0',
		description='Tetris clone with fancy Mandelbrot fractals.',
		author='Phil Hassey',
		author_email='philhassey@yahoo.com',
		url='http://www.imitationpickles.org/ftetris/',
		
		ext_modules=[
			Extension('_effects', ['effects.i','effects.c'],
				include_dirs=[
					'/usr/include/SDL',
					'/mingw/sdl/include/sdl',
					],
				library_dirs=[
					'/mingw/sdl/lib',
					],
				extra_compile_args=['-D_REENTRANT','-O3'],
				),
			],
		)

if cmd in ('py2exe',):
	setup(
		options={'py2exe':{
			'dist_dir':'dist',
			'dll_excludes':['_dotblas.pyd','_numpy.pyd']
			}},
		windows=[{
			'script':'ftetris.py',
			'icon_resources':[(1,'icon.ico')],
			}],
		)
		
if cmd in ('build',):
	for fname in glob.glob("build/lib*/*.so"):
		shutil.copy(fname,os.path.basename(fname))
		
	for fname in glob.glob("build/lib*/*.pyd"):
		shutil.copy(fname,os.path.basename(fname))
		
	
if cmd in ('py2exe',):
	for gname in data:
		for fname in glob.glob(gname):
			dname = os.path.join('dist',os.path.dirname(fname))
			try: 
				os.mkdir(dname)
			except:
				'mkdir failed: '+dname
			shutil.copy(fname,dname)
	